<div class="role-settings">
  {#if role}
  <TextInput value={role.name} bind:value=roleName name="Name" />
  <!-- <ColorInput value={color} bind:value=roleColor name="Color" /> -->

  <!-- <span class="permission-bits-holder"> -->
  <!--   Calculated: -->
  <!--   <span class="permission-bits">({permissionBits})</span> -->
  <!-- </span> -->
  {#each permissions as permission (permission.value)}
  <PermissionSwitch value={(permissionBits & permission.value)===permission.value} name={permission.name} on:toggle="onPermissionToggle(permission.value, event, permissionBits)"
   permission={permission.value} /> {/each}

  <Button {disabled} text="Apply" on:click="edit({permissions: permissionBits, name: roleName, color: roleColor}, role, role.guildId)"
  />
  <Button {disabled} text="Delete" color="danger" on:click="deleteRole(role.guildId, role.id)" /> {/if}
</div>

<script>
  import TextInput from "./forms/TextInput.svelte";
  import RoleStore from "../stores/RoleStore";
  import Button from "./forms/Button.svelte";
  import PermissionSwitch from "./PermissionSwitch.svelte";
  import RestClient from "../js/RestClient";
  import constants from "../js/constants";

  const permissions = [];
  for (const permissionName in constants.permissions) {
    const value = constants.permissions[permissionName];
    permissions.push({
      value,
      name: permissionName
    });
  }

  export default {
    components: {
      Button,
      PermissionSwitch,
      TextInput
    },
    data() {
      return {
        permissions
      };
    },
    methods: {
      onPermissionToggle(permissionBits, value, currentBits) {
        console.log("TOGGLE!", permissionBits, value, currentBits);
        if (value) {
          currentBits |= permissionBits;
        } else {
          // not 100% sure on this...
          currentBits -= currentBits & permissionBits;
        }
        this.set({permissionBits: currentBits});
      },
      async deleteRole(guildId, roleId) {
        await RestClient.delete(`/guilds/${guildId}/roles/${roleId}`);
        RoleStore.unslurp({id: roleId});
      },
      async edit(changes, role, guildId) {
        const delta = {};
        for (const changeKey in changes) {
          if (changes[changeKey] != role[changeKey])
            delta[changeKey] = changes[changeKey];
        }
        if (Object.keys(delta).length) {
          const res = await RestClient.patch(
            `/guilds/${guildId}/roles/${role.id}`,
            delta
          );
          RoleStore.slurp(res);
        }
      },
      onChange(changed) {
        console.log(
          "RoleSettings; RoleStore changed!",
          changed,
          new Error("damb")
        );
        const got = this.get();
        if (changed.id == got.id) {
          this.set({
            role: changed,
            permissionBits: changed.permissions || 0
          });
        }
      }
    },
    computed: {
      name({role}) {
        return role && role.name;
      },
      color({role}) {
        return role && role.color;
      }
    },
    onstate({current, changed}) {
      if (changed.id && current.id) {
        const role = RoleStore.getItem(current.id);
        if (role) this.onChange(role);
        else {
          this.set({
            role: undefined
          });
        }
      }
    },
    ondestroy() {
      RoleStore.removeListener("change", this.onChangeBound);
    },
    oncreate() {
      this.onChangeBound = this.onChange.bind(this);
      RoleStore.on("change", this.onChangeBound);
      const got = this.get();
      if (got && got.id) {
        const tempRole = RoleStore.getItem(got.id);
        if (tempRole) this.onChange(tempRole);
      }
    }
  };
</script>

<style>
  .role-settings {
    max-height: 89vh;
    overflow-y: auto;
  }

  /*.permission-bits {
                      font-weight: 700;
                      font-size: 0.8em;
                      color: #b9b9b9;
                    }*/
</style>
